/*jslint node:true, nomen: true*/
(function () {
    'use strict';

    var cfg = require('./lib/cfg'),
        _ = require('underscore'),
        modules = {};

    /*jslint unparam: true*/
    _.each(cfg, function (module, id) {
        // Converting module name to camel case (pack-lib => packLib)
        modules[id.replace(/-(\w)/,  function (m, group) { return group.toUpperCase(); })] = function (args, callback) {
            /*jslint unparam: false*/
            var error = '';

            _.each(module.args, function (argument) {
                var alias = argument.alias[1].split('--').pop().replace('-', '_');
                error += (argument.required && !args[alias]) ? 'Parameter ' + alias + ' is wrong or missing\n' : '';
            });

            if (!error) { module.exec(args, callback); } else { callback(error); }
        };
    });

    module.exports = modules;
}());