/*jslint node:true, nomen:true*/
/*global describe,before,it,after*/

(function () {

    'use strict';

    var _ = require('underscore'),
        expect = require('expect.js'),
        sinon = require('sinon'),
        log = require('../lib/log');

    describe('Running log.js', function () {

        describe('check log API', function () {
            var levels = log.levels;

            it('should contain 6 log levels', function () {
                expect(levels.length).to.be(6);
            });

            it('should be a function', function () {
                expect(typeof log.add).to.be('function');
            });

            it('should return the value of the log level', function () {
                expect(log.getLogLevel()).to.be(0);
                expect(log.getLogLevel(['-l', 3])).to.be(3);
            });

            it('should return an object of log methods', function () {
                var methods = log.getLogger();

                _.each(levels, function (level) {
                    expect(typeof methods[level]).to.be('function');
                });
            });
        });
    });
}());